package de.thdeg.grademanager.model;

import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleStringProperty;

/**
 * This class is used for displaying data in a JavaFX TableView.
 *
 * author: Kevin Thaller
 */
public class EnrollmentProperty {


    /**
     * The variable which stores the course name.
     */
    private SimpleStringProperty courseProp;

    /**
     * The variable which stores the grade value.
     */
    private SimpleDoubleProperty gradeProp;


    /**
     * Assign the attributes of an Enrollment-Object to the private Properties.
     *
     * author: Kevin Thaller
     *
     * @param enrollment the object to assign
     */
    public EnrollmentProperty(Enrollment enrollment) {
        courseProp = new SimpleStringProperty(enrollment.getCourse().getName());
        gradeProp = new SimpleDoubleProperty(enrollment.getGrade());
    }

    /**
     * This method is used for filling the TableView.
     *
     * author: Kevin Thaller
     *
     * @return the value of the courseProp-Object.
     */
    public String getCourseProp() {
        return courseProp.get();
    }

    /**
     *  This method is used for filling the TableView.
     *
     *  author: Kevin Thaller
     *
     * @return the value of the gradeProp-Object.
     */
    public double getGradeProp() {
        return gradeProp.get();
    }


}
